### R code from vignette source 'popMeans.Rnw'

###################################################
### code chunk number 1: popMeans.Rnw:59-65
###################################################
library(doBy)
dd <- expand.grid(A=factor(1:3),B=factor(1:3),C=factor(1:2))
dd$y <- rnorm(nrow(dd))
dd$x <- rnorm(nrow(dd))^2
dd$z <- rnorm(nrow(dd))
head(dd,10)


###################################################
### code chunk number 2: popMeans.Rnw:76-78
###################################################
mm <- lm(y~A+B+C, data=dd)
coef(mm)


###################################################
### code chunk number 3: popMeans.Rnw:101-103
###################################################
w <- c(0,-1,1,0,0,0)
sum(coef(mm)*w)


###################################################
### code chunk number 4: popMeans.Rnw:109-110
###################################################
esticon(mm, w)


###################################################
### code chunk number 5: popMeans.Rnw:160-163
###################################################
w <- c(1, 0, 0, 1/3, 1/3, 1/2)
coef(mm)*w
sum(coef(mm)*w)


###################################################
### code chunk number 6: popMeans.Rnw:169-174
###################################################
W <- matrix(c(1, 0, 0, 1/3, 1/3, 1/2,
              1, 1, 0, 1/3, 1/3, 1/2,
              1, 0, 1, 1/3, 1/3, 1/2),nr=3, byrow=TRUE)
W
W %*% coef(mm)


###################################################
### code chunk number 7: popMeans.Rnw:189-190
###################################################
esticon(mm, W)


###################################################
### code chunk number 8: popMeans.Rnw:203-205
###################################################
pma <- popMatrix(mm,effect='A')
summary(pma)


###################################################
### code chunk number 9: popMeans.Rnw:213-215
###################################################
pme <- popMeans(mm, effect='A')
pme


###################################################
### code chunk number 10: popMeans.Rnw:221-222
###################################################
summary(pme)


###################################################
### code chunk number 11: popMeans.Rnw:232-233
###################################################
popMatrix(mm,effect=c('A','C'))


###################################################
### code chunk number 12: popMeans.Rnw:239-240
###################################################
popMeans(mm)


###################################################
### code chunk number 13: popMeans.Rnw:251-252
###################################################
popMatrix(mm,effect='A', at=list(C='1'))


###################################################
### code chunk number 14: popMeans.Rnw:257-258
###################################################
popMatrix(mm,effect='A', at=list(C=c('1','2')))


###################################################
### code chunk number 15: popMeans.Rnw:264-265
###################################################
popMatrix(mm,effect='A', at=list(C=c('1','2'), B='1'))


###################################################
### code chunk number 16: popMeans.Rnw:274-275
###################################################
popMatrix(mm,effect=c('A','C'), at=list(C='1'))


###################################################
### code chunk number 17: popMeans.Rnw:286-287 (eval = FALSE)
###################################################
## popMatrix(mm,effect='A', at=list(C='1'))


###################################################
### code chunk number 18: popMeans.Rnw:294-296
###################################################
mm2 <- lm(y~A+B+C+C:x, data=dd)
coef(mm2)


###################################################
### code chunk number 19: popMeans.Rnw:300-301
###################################################
popMatrix(mm2,effect='A', at=list(C='1'))


###################################################
### code chunk number 20: popMeans.Rnw:308-309
###################################################
popMatrix(mm2,effect='A', at=list(C='1',x=12))


###################################################
### code chunk number 21: popMeans.Rnw:317-319
###################################################
mm3 <- lm(y~A+B+C+C:log(x), data=dd)
coef(mm3)


###################################################
### code chunk number 22: popMeans.Rnw:327-330
###################################################
dd <- transform(dd, log.x = log(x))
mm3 <- lm(y~A+B+C+C:log.x, data=dd)
popMatrix(mm3,effect='A', at=list(C='1'))


###################################################
### code chunk number 23: popMeans.Rnw:346-349
###################################################
 library(multcomp)
g<-popMeans(mm,effect='A', at=list(C='1'),engine="glht")
g


###################################################
### code chunk number 24: popMeans.Rnw:353-355
###################################################
summary(g,test=univariate())
confint(g,calpha=univariate_calpha())


###################################################
### code chunk number 25: popMeans.Rnw:360-362
###################################################
summary(g)
confint(g)


